//--------------------------------------//
//	fobNJNX					//
//										//
//	쐬	Daiki Terai					//
//	쐬	2011/07/28					//
//	C								//
//--------------------------------------//

#ifndef _DEBUGCAMERA_H_
#define _DEBUGCAMERA_H_

#include "directinput.h"
#include "camera.h"

// fobNJNX
class DebugCamera : public Camera
{
public:
	// JXV
	void DebugUpdate(DirectInput& Input,float MoveCamZScale = 0.02f,float MoveCamXYScale = 0.2f,float RotScale = 1.0f);

	//------------------------------------------------
	//	ړxNg擾iJʕj
	//
	//	F	Input		DirectInput
	//			FrontKey	OړL[
	//			BackKey		ړL[
	//			LeftKey		ړL[		
	//			RightKey	EړL[
	//
	//	߂lFړxNg
	//------------------------------------------------
	D3DXVECTOR3 GetMove(
		DirectInput& Input,
		UINT FrontKey = DIK_W,
		UINT BackKey = DIK_S,
		UINT LeftKey = DIK_A,
		UINT RightKey = DIK_D);

	
};

#endif
