#include "directshow.h"

//--------------------------------------------------------//
// qedit.hdxtrans.h݂͑Ȃ
#pragma include_alias( "dxtrans.h", "qedit.h" )	// dxtrans.h͂Ȃ̂Ŗ
// qedit.h̒``Ŗ
#define __IDxtCompositor_INTERFACE_DEFINED__
#define __IDxtAlphaSetter_INTERFACE_DEFINED__
#define __IDxtJpeg_INTERFACE_DEFINED__
#define __IDxtKey_INTERFACE_DEFINED__
//--------------------------------------------------------//

#include <dshow.h>
#include <qedit.h> // SampleGrabberp
#pragma comment(lib,"strmiids.lib")


AM_MEDIA_TYPE am_media_type = {};
VIDEOINFOHEADER videoInfo = {};
BITMAPINFOHEADER bmiHeader = {};

// RXgN^
DirectShow::DirectShow():
	m_isPlay(false),
	m_Width(0),
	m_Height(0),
	m_BufferSize(0),
	m_pGraphBuilder(NULL),
	m_pMediaControl(NULL),
	m_pMediaEvent(NULL),
	m_pMediaSeeking(NULL),
	m_pVideoWindow(NULL),
	m_pBasicVideo(NULL),
	m_pCaptureGraphBuilder2(NULL),
	m_pCreateDevEnum(NULL),
	m_pEnumMoniker(NULL),
	m_pMoniker(NULL),
	m_pDeviceFilter(NULL),
	m_pSampleGrabberFilter(NULL),
	m_pSampleGrabber(NULL),
	m_pNullFilter(NULL),
	m_pVideoFilter(NULL)	
{
	// COMCu
	::CoInitialize(NULL);
}

// fXgN^
DirectShow::~DirectShow(){
	this->Release();
	// COMCuI
	::CoUninitialize();
}

void DirectShow::Release(){

	// KXgbvĂI邱
	if(m_pMediaControl != NULL)
		m_pMediaControl->Stop();

	SafeRelease(m_pVideoFilter);
	SafeRelease(m_pNullFilter);
	SafeRelease(m_pSampleGrabberFilter);
	SafeRelease(m_pSampleGrabber);

	SafeRelease(m_pDeviceFilter);
	SafeRelease(m_pMoniker);
	SafeRelease(m_pEnumMoniker);
	SafeRelease(m_pCreateDevEnum);
	SafeRelease(m_pCaptureGraphBuilder2);

	SafeRelease(m_pBasicVideo);
	SafeRelease(m_pVideoWindow);
	SafeRelease(m_pMediaSeeking);
	SafeRelease(m_pMediaEvent);
	SafeRelease(m_pMediaControl);
	SafeRelease(m_pGraphBuilder);

}

// ڑs擾
HRESULT GetUnconnectedPin(
    IBaseFilter* pFilter,   // tB^ւ̃|C^
    PIN_DIRECTION PinDir,   // Tš
    IPin **ppPin)           // sւ̃|C^i[
{
    *ppPin = 0;
    IEnumPins *pEnum = 0;
    IPin *pPin = 0;
    HRESULT hr = pFilter->EnumPins(&pEnum);
    if (FAILED(hr))
    {
        return hr;
    }
    while (pEnum->Next(1, &pPin, NULL) == S_OK)
    {
        PIN_DIRECTION ThisPinDir;
        pPin->QueryDirection(&ThisPinDir);
        if (ThisPinDir == PinDir)
        {
            IPin *pTmp = 0;
            hr = pPin->ConnectedTo(&pTmp);
            if (SUCCEEDED(hr))  // ڑς݁B̒TĂsł͂Ȃ
            {
                pTmp->Release();
            }
            else  // Ks͌Ȃ
            {
                pEnum->Release();
                *ppPin = pPin;
                return S_OK;
            }
        }
        pPin->Release();
    }
    pEnum->Release();
    // Ks͌Ȃ
    return E_FAIL;
}

// sŃtB^ڑ
HRESULT ConnectFilters(IGraphBuilder* pGraph, IBaseFilter* pSrc, 
                   IBaseFilter *pDest)
{
    IPin *pOut = 0, *pIn = 0;
    HRESULT hr = GetUnconnectedPin(pSrc, PINDIR_OUTPUT, &pOut);
    if (FAILED(hr)) 
    {
        return hr;
    }
    hr = GetUnconnectedPin(pDest, PINDIR_INPUT, &pIn);
    if (FAILED(hr))
    {
        pIn->Release();
        return hr;
    }
    hr = pGraph->Connect(pOut, pIn);
    pOut->Release();
    pIn->Release();
    return hr;
}


// Ot쐬
bool DirectShow::LoadVideo(const TCHAR* FileName,HWND hWnd){


	// FilterGraph𐶐
	CoCreateInstance(CLSID_FilterGraph,
		NULL,
		CLSCTX_INPROC,
		IID_IGraphBuilder,
		(LPVOID *)&m_pGraphBuilder);

	// SampleGrabber(Filter)𐶐
	CoCreateInstance(CLSID_SampleGrabber,
		NULL,
		CLSCTX_INPROC,
		IID_IBaseFilter,
		(LPVOID *)&m_pSampleGrabberFilter);

	// FilterISampleGrabberC^[tF[X擾܂
	m_pSampleGrabberFilter->QueryInterface(IID_ISampleGrabber,
		(LPVOID *)&m_pSampleGrabber);

	// SampleGrabberڑtH[}bgwB
	// |CgłB
	// ̎w̎dɂSampleGrabbeȓ}ӏ
	// ł܂B̃Tv̂悤Ȏw
	// ʏo͂̐OŃTv擾ł܂B
	ZeroMemory(&am_media_type, sizeof(am_media_type));
	am_media_type.majortype = MEDIATYPE_Video;
	am_media_type.subtype = MEDIASUBTYPE_RGB32;	// OtBbN{[ȟ݂̃fBXvCo͐FiRQrbgɂĂƁj
	am_media_type.formattype = FORMAT_VideoInfo;
	m_pSampleGrabber->SetMediaType(&am_media_type);


	// GraphSampleGrabber Filterǉ
	m_pGraphBuilder->AddFilter(m_pSampleGrabberFilter,
		L"Sample Grabber");

	// MediaControlC^[tF[X擾
	m_pGraphBuilder->QueryInterface(IID_IMediaControl,
		(LPVOID *)&m_pMediaControl);

	// MediaEventC^[tF[X擾
	m_pGraphBuilder->QueryInterface(IID_IMediaEvent,
		(LPVOID *)&m_pMediaEvent);

	// MediaSeekingC^[tF[X擾
	m_pGraphBuilder->QueryInterface(IID_IMediaSeeking,
		(LPVOID *)&m_pMediaSeeking);


	// Graph𐶐B
	// SampleGrabber܂GraphIɍ쐬܂B
	if(FAILED(m_pMediaControl->RenderFile(_bstr_t(FileName)))){
		ASSERT_MSG(_T("Ot쐬sAt@C邩`FbNĂn"));
		return false;
	}

	// ڑ擾B
	// ̏RenderFileɂGraph\ꂽ
	// sKv܂B
	m_pSampleGrabber->GetConnectedMediaType(&am_media_type);
	VIDEOINFOHEADER *pVideoInfoHeader =
		(VIDEOINFOHEADER *)am_media_type.pbFormat;

	// 摜ifj̕ƍ
	m_Width = pVideoInfoHeader->bmiHeader.biWidth,
	m_Height = pVideoInfoHeader->bmiHeader.biHeight;

	// f[^TCY
	m_BufferSize = am_media_type.lSampleSize;

	// Grabsݒ
	// SetBufferSamplessȂƃobt@
	// f[^擾ł܂B
	// sKvɕׂȂꍇɂFALSEɂĂāA
	// f[^擾ȂATRUEɕς
	// Ƃ@ł܂B
	m_pSampleGrabber->SetBufferSamples(TRUE);

	// rfIEBhE쐬
	if(FAILED(m_pGraphBuilder->QueryInterface(
		IID_IVideoWindow,
		(LPVOID *)&m_pVideoWindow))){
		ASSERT_MSG(_T("rfIEBhE쐬s\n"));
		return false;
	}

	// rfIEBhE\
	if(hWnd == NULL){
		m_pVideoWindow->put_AutoShow(0);
		m_pVideoWindow->put_Visible(0);
	}
	else{


		// EBhE֘At
		// ɃOt쐬ĂȂƎs
		if(FAILED(m_pVideoWindow->put_Owner((OAHWND)hWnd))){
			ASSERT_MSG(_T("EBhEɊ֘Ats\n"));
			return false;
		}
		// EBhEX^C			
		if(FAILED(m_pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS))){
			ASSERT_MSG(_T("EBhEX^CZbgɎs\n"));
			return false;
		}

		RECT rect;
		GetClientRect(hWnd,&rect);
		// EBhEʒuTCYw
		m_pVideoWindow->SetWindowPosition(0, 0,
			rect.right - rect.left, rect.bottom - rect.top);
		// EBhEőOʂɏo
		m_pVideoWindow->SetWindowForeground(OATRUE);
		// EBhE\
		m_pVideoWindow->put_Visible(OATRUE);
	}


	return true;
}



// Ot쐬(USBJLv`[)
bool DirectShow::Capture(HWND hWnd){

	
	// tB^[Ot}l[W쐬
	CoCreateInstance(CLSID_FilterGraph,
		NULL,
		CLSCTX_INPROC,
		IID_IGraphBuilder,
		(LPVOID *)&m_pGraphBuilder);

	// MediaControlC^[tF[X擾
	m_pGraphBuilder->QueryInterface(
		IID_IMediaControl,
		(LPVOID *)&m_pMediaControl);

	// MediaEventC^[tF[X擾
	m_pGraphBuilder->QueryInterface(IID_IMediaEvent,
		(LPVOID *)&m_pMediaEvent);


	// Lv`pOt}l[W쐬
	CoCreateInstance(
		CLSID_CaptureGraphBuilder2, 
		NULL, 
		CLSCTX_INPROC, 
		IID_ICaptureGraphBuilder2, 
		(LPVOID *)&m_pCaptureGraphBuilder2);


	//-------------------------Source Filter----------------------------------------//

	// foCX񋓂邽߂CreateDevEnum쐬
	CoCreateInstance(
		CLSID_SystemDeviceEnum,
		NULL,
		CLSCTX_INPROC_SERVER, 
		IID_ICreateDevEnum, 
		(PVOID *)&m_pCreateDevEnum);
	
	// rfIfoCX񋓂邽߂EnumMoniker쐬
	m_pCreateDevEnum->CreateClassEnumerator(
		CLSID_VideoInputDeviceCategory,
		&m_pEnumMoniker, 0);


	// ڑꂽf̓foCXꍇ
	if (m_pEnumMoniker == NULL) {
		ASSERT_MSG(_T("rfIJfoCX܂\n"));
		return false;
	}

	// EnumMonikerReset
	// ResetƁA擪琔Ȃ܂
	m_pEnumMoniker->Reset();

	// ŏ̃foCX擾
	ULONG nFetched = 0;
	m_pEnumMoniker->Next(1, &m_pMoniker, &nFetched);

	// foCXtB^[ɃoCh
	if(FAILED(m_pMoniker->BindToObject(
		0, 0,
		IID_IBaseFilter,
		(void**)&m_pDeviceFilter)))
	{
		ASSERT_MSG(_T("rfIJfoCXtB^[ɃoChs\n"));
		return false;
	}


	//-----------------------------------Transform Filter------------------------------------//

	// TvOotB^[𐶐
	CoCreateInstance(CLSID_SampleGrabber,
		NULL,
		CLSCTX_INPROC,
		IID_IBaseFilter,
		(LPVOID *)&m_pSampleGrabberFilter);

	// TvOotB^[ISampleGrabberC^[tF[X擾܂
	m_pSampleGrabberFilter->QueryInterface(
		IID_ISampleGrabber,
		(LPVOID *)&m_pSampleGrabber);

	// TvOoڑtH[}bgw
	// ̎w̎dɂTvOȏ}ӏ肷
	// ʏo͂̐OŃTv擾ݒs

	// ݂̃rbg[x擾B
	HDC hdc = GetDC(NULL);
	int iBitDepth = GetDeviceCaps(hdc, BITSPIXEL);
	ReleaseDC(NULL, hdc);

	// fBA^Cvݒ肷B
	am_media_type.majortype = MEDIATYPE_Video;	// OtBbN{[ȟ݂̃fBXvCo͐FiRQrbgɂĂƁj
	switch (iBitDepth)
	{
	case 8:
		am_media_type.subtype = MEDIASUBTYPE_RGB8;
		break;
	case 16:
		am_media_type.subtype = MEDIASUBTYPE_RGB555;
		break;
	case 24:
		am_media_type.subtype = MEDIASUBTYPE_RGB24;
		break;
	case 32:
		am_media_type.subtype = MEDIASUBTYPE_RGB32;
		break;
	default:
		return false;
	}

	//am_media_type.formattype = GUID_NULL;			// tH[}bg^Cv
	am_media_type.formattype = FORMAT_VideoInfo;		// tH[}bg^Cv
	bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmiHeader.biWidth = 1600;
	bmiHeader.biHeight = 1200;
	bmiHeader.biPlanes = 1;
	bmiHeader.biBitCount = 32;
	bmiHeader.biCompression = 0;
	bmiHeader.biSize = bmiHeader.biWidth * bmiHeader.biHeight * sizeof(DWORD);
	bmiHeader.biXPelsPerMeter = 0;
	bmiHeader.biYPelsPerMeter = 0;
	bmiHeader.biClrImportant = 0;
	bmiHeader.biClrUsed = 0;
	videoInfo.bmiHeader = bmiHeader;
	am_media_type.cbFormat = sizeof(VIDEOINFOHEADER);
	am_media_type.pbFormat = (BYTE*)&videoInfo;
	am_media_type.bFixedSizeSamples = TRUE;
	am_media_type.bTemporalCompression = FALSE;
	am_media_type.lSampleSize = bmiHeader.biSize;

	if(FAILED(m_pSampleGrabber->SetMediaType(&am_media_type))){
		ASSERT_MSG(_T("OoɃfBA^CvZbg쐬s\n"));
		return false;
	}

	//-----------------------------------Renderer Filter------------------------------------//

	if(hWnd == NULL){
		// Null_OtB^쐬(ʏo͂Ȃ_OtB^)
		if(FAILED(CoCreateInstance(
			CLSID_NullRenderer, NULL, CLSCTX_INPROC_SERVER,
			IID_IBaseFilter, (void**)&m_pNullFilter)))
		{
			ASSERT_MSG(_T("Null_OtB^쐬s\n"));
			return false;
		}
	}
	else{
		// Video_OtB^쐬(qEBhEƂďo͂̂Ŋ֘At)
		if(FAILED(CoCreateInstance(
			CLSID_VideoRenderer, NULL, CLSCTX_INPROC_SERVER,
			IID_IBaseFilter, (void**)&m_pVideoFilter)))
		{
			ASSERT_MSG(_T("Video_OtB^쐬s\n"));
			return false;
		}
	}

	//-----------------------------------GraphɒǉƐڑ------------------------------------//

	// tB^[Ot}l[W[Source Filterǉ
	m_pGraphBuilder->AddFilter(m_pDeviceFilter, L"Device Filter");
	// tB^[Ot}l[W[Transform Filterǉ
	m_pGraphBuilder->AddFilter(m_pSampleGrabberFilter,L"Sample Grabber");
	// tB^[Ot}l[W[Render Filterǉ
	if(hWnd == NULL)
		m_pGraphBuilder->AddFilter(m_pNullFilter, L"Null Render");
	else
		m_pGraphBuilder->AddFilter(m_pVideoFilter, L"Video Render");

	if(FAILED(ConnectFilters(m_pGraphBuilder,m_pDeviceFilter,m_pSampleGrabberFilter))){
		ASSERT_MSG(_T("SourceFilterTransformFilter̐ڑs\n"));
		return false;
	}
	if(hWnd == NULL){
		if(FAILED(ConnectFilters(m_pGraphBuilder,m_pSampleGrabberFilter,m_pNullFilter))){
			ASSERT_MSG(_T("TransformFilterRendererFilter̐ڑs\n"));
			return true;
		}
	}else{
		if(FAILED(ConnectFilters(m_pGraphBuilder,m_pSampleGrabberFilter,m_pVideoFilter))){
			ASSERT_MSG(_T("TransformFilterRendererFilter̐ڑs\n"));
			return true;
		}
	}


	// Ot}l[WZbg
	if(FAILED(m_pCaptureGraphBuilder2->SetFiltergraph(m_pGraphBuilder))){
		ASSERT_MSG(_T("Ot}l[W[ɃZbgs\n"));
		return false;
	}


	// ڑ擾
	// Ot\ꂽɍs
	m_pSampleGrabber->GetConnectedMediaType(&am_media_type);
	VIDEOINFOHEADER *pVideoInfoHeader = (VIDEOINFOHEADER *)am_media_type.pbFormat;
	m_BufferSize = am_media_type.lSampleSize;	// ~~RGB(SoCg)

	// 摜ifj̕ƍ擾
	m_Width = pVideoInfoHeader->bmiHeader.biWidth;
	m_Height = pVideoInfoHeader->bmiHeader.biHeight;


	// Lv`[obt@擾̐ݒ
	// ׂ傫̂ŕsKvɕׂȂꍇ̓tO؂ւ
	m_pSampleGrabber->SetBufferSamples(TRUE);


	// rfIEBhE쐬
	if(FAILED(m_pGraphBuilder->QueryInterface(
		IID_IVideoWindow,
		(LPVOID *)&m_pVideoWindow))){
	}

	// Lv`[EBhE\
	if(hWnd == NULL){
		m_pVideoWindow->put_AutoShow(0);
		m_pVideoWindow->put_Visible(0);
	}
	else{

		// EBhE֘At
		// ɃOt쐬ĂȂƎs
		if(FAILED(m_pVideoWindow->put_Owner((OAHWND)hWnd))){
			ASSERT_MSG(_T("EBhEɊ֘Ats\n"));
			return false;
		}
		// EBhEX^C			
		if(FAILED(m_pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS))){
			ASSERT_MSG(_T("EBhEX^CZbgɎs\n"));
			return false;
		}


		RECT rect;
		GetClientRect(hWnd,&rect);
		// EBhEʒuTCYw
		m_pVideoWindow->SetWindowPosition(0, 0,
			rect.right - rect.left, rect.bottom - rect.top);
		// EBhEőOʂɏo
		m_pVideoWindow->SetWindowForeground(OATRUE);
		// EBhE\
		m_pVideoWindow->put_Visible(OATRUE);
	}


	return true;
}

// rfIorLv`[擾
long DirectShow::GetWidth(){
	return m_Width;
}
// rfIorLv`[擾
long DirectShow::GetHeight(){
	return m_Height;
}

// ݂̍ĐԂ̎擾
LONGLONG DirectShow::GetCurrentTime()
{
	if(m_pMediaSeeking == NULL)
		return 0;

	LONGLONG time;
	m_pMediaSeeking->GetCurrentPosition(&time);
	return time;
}

// ̑Ԃ̎擾
LONGLONG DirectShow::GetDuration(){
	if(m_pMediaSeeking == NULL)
		return 0;

	LONGLONG time;
	m_pMediaSeeking->GetDuration(&time);
	return time;
}

// Đ̔
bool DirectShow::IsPlaying(long TimeOut){
	long evCode;
	long param1,param2;
	if(SUCCEEDED(m_pMediaEvent->GetEvent(&evCode,&param1,&param2,0))){
		m_pMediaEvent->FreeEventParams(evCode, param1, param2);
		switch (evCode) {
			// ĐI
		case EC_COMPLETE:
			// [U[ĐI
		case EC_USERABORT:
			// ĐɃG[Ď~܂
		case EC_STREAM_ERROR_STOPPED:
			// Xg[~R}hLɂȂ
		case EC_STREAM_CONTROL_STOPPED:
			m_isPlay = false;
			break;
		}

	}
	
	return m_isPlay;
}

// ~
bool DirectShow::Stop(){
	if(m_pMediaControl == NULL)
		return false;

	if(FAILED(m_pMediaControl->Stop())){
		return false;
	}
	m_isPlay = false;
	return true;
}

// Đ(ʃXbhĐɂȂ)
bool DirectShow::Play(){
	if(FAILED(m_pMediaControl->Run())){
		return false;
	}
	m_isPlay = true;
	return true;
}

// _[eNX`bN̐擪|C^nƂŃf[^擾
// UV㉺]̂Œ
// (eNX`tH[}bg̓rfIˑʏA8R8G8B8)
bool DirectShow::GetBuffer(long* pOutBuffer){

	if(m_pMediaControl == NULL){
		return false;
	}


	// ݕ\ĂfÎ~ƂĎ擾
	if(m_pSampleGrabber != NULL && pOutBuffer != NULL){
		HRESULT hr = S_OK;
		// 擾iQxĂяoj
		m_pSampleGrabber->GetCurrentBuffer(&m_BufferSize,NULL);
		// ARGB摜擾
		if(FAILED(hr = m_pSampleGrabber->GetCurrentBuffer(&m_BufferSize,pOutBuffer))){
			switch(hr){
				case E_INVALIDARG:
					printf("E_INVALIDARG\n");
					break;
				case E_OUTOFMEMORY:
					printf("E_OUTOFMEMORY\n");
					break;
				case E_POINTER:
					printf("E_POINTER\n");
					break;
				case VFW_E_NOT_CONNECTED:
					printf("VFW_E_NOT_CONNECTED\n");
					break;
				case VFW_E_WRONG_STATE:
					//printf("VFW_E_WRONG_STATE\n");	// łĂȂ
					break;
				default:
					break;
			}
			return false;
		}
		
	}

	return true;
}

