//----------------------------------------//
//	`NX
//
//	쐬ҁFDaiki Terai
//	쐬F2011/07/23
//	CF
//----------------------------------------//

#ifndef _DRAWER_H_
#define _DRAWER_H_

#include "geometory.h"
#include "texture.h"
#include "effect.h"
#include "sprite.h"
#include "billboard.h"
#include "pointsprite.h"
#include "model.h"
#include "renderstate.h"
#include "samplerstate.h"
#include "resource.h"

static const TCHAR* FX_PLANEPOLYGON	= _T("planepolygon.cfx");
static const TCHAR* FX_POINTSPRITE	= _T("pointsprite.cfx");
static const TCHAR* FX_MESH			= _T("mesh.cfx");
static const TCHAR* FX_SKINMESH		= _T("skinmesh.cfx");

// `IuWFNg͂̃NXthɂ
class Drawer : public Geometory , public Resource
{
public:
	// 
	static bool Init(IDirect3DDevice9* pD3DDevice);
	// |S`ieNX``j
	static bool DrawPlanePolygon(PlanePolygon& planepolygon,Texture& texture);
	// |CgXvCg`
	static bool DrawPointSprite(PointSprite& pointsprite,Texture& texture);
	// bV`
	static bool DrawMesh(Mesh& mesh);
	// XLbV`
	static bool DrawSkinMesh(Mesh& skinmesh);
	// f`
	static bool DrawModel(Model& model);
};

#endif