//-----------------------------//
//	`pbV
//
//	쐬ҁF		Daiki Terai
//	쐬F		2011/08/02
//	CF
//-----------------------------//

#ifndef _MESH_H_
#define _MESH_H_

#include "direct3dmodel.h"
#include "direct3d9.h"
#include "object3d.h"
#include "stream.h"

class Mesh : public Object3D,private Stream 
{
	friend class Drawer;
public:
	LPMESH						m_pData;			// bVff[^
	unsigned int				m_StreamFlag;		// Xg[tO
	D3DXMATRIX					m_LocalToWorldMtx;	// [JԂ烏[hԂւ̕ϊs
	std::vector<D3DXMATRIX>		m_MatrixStack;		// sX^bN
public:
	// RXgN^
	Mesh();
	// fXgN^
	virtual ~Mesh();

	// ϊs̍XV
	void Update();
	// [J烏[hԂւ̕ϊs̃Zbg
	void SetLocalToWorldMatrix(const D3DXMATRIX& LocalToWorldMtx);
	// sX^bN̍쐬
	void CreateMatrixStack(std::map<std::basic_string<TCHAR>,D3DXMATRIX>& ConposedMtx);
	// bV쐬
	bool Create(IDirect3DDevice9* pD3DDevice,LPMESH pMeshData);

};

#endif