//---------------------------------//
//	\[XNX
//
//	쐬ҁF		Daiki Terai
//	쐬F		2011/08/02
//	CF
//---------------------------------//

#ifndef _RESOURCE_H_
#define _RESOURCE_H_

#include "texture.h"
#include "effect.h"
#include "direct3dmodel.h"
#include "xfileloader.h"

enum MODELFILE{
	XFILE
};

class Resource
{
protected:
	static std::map<std::basic_string<TCHAR>,Texture>	m_Textures;	// eNX`
	static std::map<std::basic_string<TCHAR>,Effect>	m_Effects;	// GtFNg
	static std::map<std::basic_string<TCHAR>,MODEL>		m_Models;	// f
public:
	static bool LoadTexture(IDirect3DDevice9* pD3DDevice,const TCHAR* FileName);
	static bool LoadTexture(IDirect3DDevice9* pD3DDevice,const TCHAR* FileName,int Width,int Height,DWORD ColorKey = 0x00000000,D3DFORMAT Format = D3DFMT_A8R8G8B8);
	static bool LoadEffect(IDirect3DDevice9* pD3DDevice,const TCHAR* FileName);
	static bool LoadModel(IDirect3DDevice9* pD3DDevice,const TCHAR* FileName,int ModelFile = XFILE);

	static Texture* GetTexture(const TCHAR* TextureName);
	static Effect* GetEffect(const TCHAR* EffectName);
	static MODEL* GetModel(const TCHAR* ModelName);
};

#endif