#include "billboard.h"


// r{[h쐬
bool BillBoard::Create(IDirect3DDevice9* pD3DDevice,int Width,int Height,
	const D3DXVECTOR3& Translate,const D3DXVECTOR3& Rotate)
{
	if(!this->CreateBuffer(pD3DDevice))
		return false;

	this->SetScale(static_cast<float>(Width),static_cast<float>(Height),1.0f);
	this->SetRotate(Rotate);
	this->SetTranslate(Translate);
	
	return true;
}	



//-------------------------------------------------------//
//	[hϊs쐬(r{[hȂ̂łႤ)
//-------------------------------------------------------//
void BillBoard::CreateWorldMatrix()
{
	D3DXMATRIX ScaleMtx,TransMtx;
	D3DXMatrixScaling(&ScaleMtx,m_Scale.x,m_Scale.y,m_Scale.z);
	D3DXMatrixTranslation(&TransMtx,m_Translate.x,m_Translate.y,m_Translate.z);
	
	// r{[hpr[ϊs̋t]s񐶐i܂Ar[ϊ̉]̑łsj
	// r[s̉]͐KWnȂ̂
	// ts͓]uŕ\
	// s͖
	D3DXMATRIX ViewRotateMtx,ViewRotateInvMtx;
	ViewRotateMtx = m_ViewMtx;
	/*
	D3DXMatrixInverse(&ViewRotateInvMtx,NULL,&ViewRotateMtx);
	ViewRotateInvMtx._41 = 0.0f;
	ViewRotateInvMtx._42 = 0.0f;
	ViewRotateInvMtx._43 = 0.0f;
	*/
	D3DXMatrixTranspose(&ViewRotateInvMtx,&ViewRotateMtx);		// ]ssȂ̂ŋtsƓÂق
	ViewRotateInvMtx._14 = 0.0f;
	ViewRotateInvMtx._24 = 0.0f;
	ViewRotateInvMtx._34 = 0.0f;
	
	this->PlanePolygon::m_WorldMtx = ScaleMtx * m_RotateMtx * ViewRotateInvMtx * TransMtx;
}

// s̍XV
void BillBoard::Update(IDirect3DDevice9* pD3DDevice)
{
	// [hϊs쐬
	this->CreateWorldMatrix();

	// XN[ϊs쐬(r[~ˉe)
	m_ToScreenMtx = Object3D::m_ViewMtx * Object3D::m_ProjMtx;

	// UV؂s쐬
	this->CreateUVMatrix();
}
