#define _CRT_SECURE_NO_WARNINGS
#define  _CRT_NON_CONFORMING_SWPRINTFS
#include "debugtext.h"

// RXgN^
DebugText::DebugText()
	:m_pDXFont(NULL)
{
}

// fXgN^
DebugText::~DebugText()
{
	SafeRelease(m_pDXFont);
}

// DirectXtHg쐬
bool DebugText::CreateDXFont(IDirect3DDevice9* pD3DDevice,int FontHeight)
{
	HFONT	hFont = NULL;	// tHgnh
	LOGFONT	LogFont ={};	// tHg\

	// ftHgtHg擾
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	// ftHgtHg擾
	GetObject( hFont, sizeof(LOGFONT), &LogFont);
	// DirectXtHg쐬
	if(FAILED(D3DXCreateFont(pD3DDevice, 
		FontHeight,					// 
		LogFont.lfWidth,			// 
		LogFont.lfWeight,			// tHg̑
		0,							// ~bv}bvx
		LogFont.lfItalic,			// C^bNtO
		LogFont.lfCharSet,			// Zbg
		LogFont.lfOutPrecision,		// ۂ̃tHgƖړĨtHg̓̈v@
		LogFont.lfQuality,			// NHeB
		LogFont.lfPitchAndFamily,	// sb`ƃt@~CfbNX
		LogFont.lfFaceName,			// tHg
		&m_pDXFont)))
	{
		return false;
	}
	

	return true;
}


// ̕`
void DebugText::Draw(DWORD Color,int x,int y,const TCHAR* Str,...)
{
	va_list args;
	va_start( args, Str );					// ψ̍ŏ̗vfi[
	int len = _vsctprintf( Str, args ) + 1;	// JEgAk
	if(m_Buf.size() < (UINT)len)
		m_Buf.resize(len);						// TCYIɃm
	_vstprintf( &m_Buf[0], Str, args );			// 𐮌`

	SetRect( &m_Rect, 0,0,0,0 );
	// `̈TCY擾
	m_pDXFont->DrawText(NULL, &m_Buf[0], -1, &m_Rect, DT_LEFT | DT_CALCRECT, Color);
	// {`
	m_Rect.left += x;
	m_Rect.right += x;
	m_Rect.top += y;
	m_Rect.bottom += y;
	m_pDXFont->DrawText(NULL, &m_Buf[0], -1, &m_Rect, DT_LEFT, Color);
}
