// ---------------------------------------------------------------
//	Tv:			DirectSound֌W
//	t@C:		DirectSound.h
//
//	쐬	Daiki Terai
//	쐬	2009/12/22
//	C	
// ---------------------------------------------------------------

// CN[hK[h
#ifndef _DIRECTSOUND_H_
#define _DIRECTSOUND_H_


/*--------------------Libs-------------------------*/
#pragma comment(lib, "dsound.lib")
#pragma comment(lib, "d3dxof.lib")
#pragma comment(lib, "dxguid.lib")
/*--------------------Includes---------------------*/

#define DIRECTSOUND_VERSION 0x800	// DirectSound̃o[W

#include "SafeFree.hpp"

#include <comdef.h>
#include <dsound.h>
#include <windows.h>
#include <tchar.h>
#include <d3d9.h>
#include <d3dx9.h>

/*------------------------------------------------*/




// DirectSoundNX
class DirectSound
{
private:

	IDirectSound8*				m_pDirectSound8;	// DirectSoundfoCX
	LPDIRECTSOUND3DLISTENER8	m_pListener;		// Xi[
	DSCAPS						m_DSCaps;			// TEhfoCX̐\
public:

	//----------------------------------------------
	//	RXgN^
	//----------------------------------------------
	DirectSound();

	//----------------------------------------------
	//	fXgN^
	//----------------------------------------------
	virtual ~DirectSound();
	

	// ---------------------------------------------------------------
	//	DirectSound쐬
	//
	//					hWnd				EBhEnh
	//
	//	߂l			true				
	//					false				s
	// ---------------------------------------------------------------
	bool Create(HWND hWnd);

	//--------------------------------------------
	//	TEhfoCX̎擾
	//
	//			Ȃ
	//	
	//	߂l	DirectSound
	//--------------------------------------------
	IDirectSound8* GetDevice();

	//-----------------------------------------------------------------
	// Xi[ʒuA̐ݒ
	//	
	//			Pos			ʒuxNg
	//			Dir			ÕxNg
	//			Up			AbvxNg
	//
	//	߂l	Ȃ
	//-----------------------------------------------------------------
	void SetPosDir(const D3DXVECTOR3& Pos,const D3DXVECTOR3& Dir,const D3DXVECTOR3& Up);

	//------------------------------------------------------------------
	//	[ItiXi[ARcԂ̋ɂ鉹̌j̐ݒ
	//
	//			flRolloffFactor		[Itli0.0f`10.0f̒lj
	//			
	//	߂l	Ȃ
	//------------------------------------------------------------------
	void SetRolloff(float flRolloffFactor);

};





#endif // _DIRECTSOUND_H_
