#include "mesh.h"


// RXgN^
Mesh::Mesh():m_pData(NULL),m_StreamFlag(0)
{
	D3DXMatrixIdentity(&m_LocalToWorldMtx);
}

// fXgN^
Mesh::~Mesh()
{}

// ϊs̍XV
void Mesh::Update()
{
	// [hi[Jjϊs쐬
	this->CreateWorldMatrix();
	// [JԂ烏[hԂւ̕ϊs|
	m_WorldMtx *= m_LocalToWorldMtx;
}

// [J烏[hԂւ̕ϊs̃Zbg
void Mesh::SetLocalToWorldMatrix(const D3DXMATRIX& LocalToWorldMtx)
{
	m_LocalToWorldMtx = LocalToWorldMtx;
}

// sX^bN̍쐬
void Mesh::CreateMatrixStack(std::map<std::basic_string<TCHAR>,D3DXMATRIX>& ConposedMtx)
{
	for(unsigned int i = 0;i < m_pData->Skins.size();++i){
		m_MatrixStack[i] = m_pData->Skins[i].OffsetMtx * ConposedMtx[m_pData->Skins[i].BoneName];
	}
}

// bV쐬
bool Mesh::Create(IDirect3DDevice9* pD3DDevice,LPMESH pMeshData)
{
	if(pMeshData == NULL)
		return false;
	m_pData = pMeshData;

	if( (m_pData->Format & VF_POS) && (m_pData->Format & VF_NORMAL) )
		m_StreamFlag |= STREAM_POSNOR0;
	if( m_pData->Format & VF_UV )
		m_StreamFlag |= STREAM_UV;
	if( m_pData->Format & VF_SKIN){
		m_StreamFlag |= STREAM_SKIN;
		// sX^bN쐬
		m_MatrixStack.resize(m_pData->Skins.size());
	}

	this->CreateStream(pD3DDevice,m_pData,m_StreamFlag);
	return true;
}