//------------------------------------------------
// O[oϐ
//------------------------------------------------
float4x4 	g_mWorld;
float4x4 	g_mView;
float4x4 	g_mProj;
float		g_Time;
float3		g_Accel = {0.0f,0.0f,0.0f};
float		g_ViewportHeight;
texture 	g_Texture;

	
//------------------------------------------------
// eNX`Tv
//------------------------------------------------
sampler TextureSampler = 
sampler_state
{
    Texture = <g_Texture>;
    	
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


//------------------------------------------------
//	_VF[_
//------------------------------------------------
void BasicVS( 	float3 in_pos : POSITION,
 				float  in_size :PSIZE,
 				float3 in_dir : TEXCOORD0,
 				float  in_life : TEXCOORD1,
 				float  in_start : TEXCOORD2,
 				out float4 out_pos : POSITION,
 				out float2 out_tex: TEXCOORD0,
 				out float  out_size :PSIZE,
 				out float4 out_color : COLOR
 				)
{


	// Ԃ̌v
	float time = in_start + g_Time;
	
	// Aj[V̌JԂl
	time = fmod(time, in_life);
	
	// |CgXvCg̈ʒuvZ
	float4 pos;
	pos = float4(in_pos + in_dir*time + 0.5 * g_Accel * time * time,1.0f);
	
	// Wϊ
	pos = mul(pos, g_mWorld);
	pos = mul(pos, g_mView);
	out_pos = mul(pos, g_mProj);
	
	// eNX`W͏o͂ȂĂɖ߂Ă
	out_tex = 0.0;
	// TCY
	out_size = in_size * g_mProj._m11 / out_pos.w * g_ViewportHeight / 2;
	// At@lԌ
	out_color.rgb = 1.0;
	out_color.a = 1.0 - time / in_life;
}


//------------------------------------------------
// sNZVF[_
//------------------------------------------------
void BasicPS( float2 in_tex : TEXCOORD0,
			  float4 in_color : COLOR0,
              out float4 out_color : COLOR)
{	
	// F̏o
	out_color = tex2D(TextureSampler, in_tex) * in_color.a;
}

//------------------------------------------------
// eNjbN錾
//------------------------------------------------
technique T0
{
	// ʏ
    pass Default
    {
        vertexShader = compile vs_2_0 BasicVS();
        pixelShader  = compile ps_2_0 BasicPS();
	
		POINTSPRITEENABLE = TRUE;	// |CgXvCgL
		POINTSCALEENABLE = FALSE;	// _TCYύXi_VF[_ŌvZj
		
	}
	
}
