#include "samplerstate.h"


// Tv[Xe[g̕ύX
void SetSamplerState(IDirect3DDevice9* pD3DDevice,SAMPLERSTATE SamplerState){
	switch(SamplerState){
		case SAMPLER_POINT:
			{
				//_tB^
				pD3DDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_POINT);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MINFILTER,D3DTEXF_POINT);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MIPFILTER,D3DTEXF_POINT);
				break;
			}
		case SAMPLER_LINEAR:
			{
				//`tB^
				pD3DDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MINFILTER,D3DTEXF_LINEAR);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MIPFILTER,D3DTEXF_LINEAR);
				break;
			}
		case SAMPLER_PYRAMIDALQUAD:
			{
				//Op`tB^
				pD3DDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_PYRAMIDALQUAD);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MINFILTER,D3DTEXF_PYRAMIDALQUAD);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MIPFILTER,D3DTEXF_PYRAMIDALQUAD);
				break;
			}
		case SAMPLER_ANISOTROPIC:
			{
				//ٕtB^
				pD3DDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_ANISOTROPIC);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MINFILTER,D3DTEXF_ANISOTROPIC);
				pD3DDevice->SetSamplerState(0,D3DSAMP_MIPFILTER,D3DTEXF_ANISOTROPIC);
				break;
			}
	}
}
