//-------------------------------//
//	Xg[NX
//
//	TvF`ɕKvȃXg[쐬
//
//	쐬ҁFDaiki Terai
//	쐬F2010/04/08
//	C
//-------------------------------//

#ifndef _STREAM_H_
#define _STREAM_H_

#include "direct3d9.h"
#include "direct3dmodel.h"
#include <vector>



// Xg[tOɉč쐬
enum STREAMFLAG
{
	STREAM_POSNOR0	= (1 << 0),	// _ʒu
	STREAM_TANGENT	= (1 << 1),	// ڐ
	STREAM_UV		= (1 << 2),	// UVW
	STREAM_COLOR	= (1 << 3),	// _J[
	STREAM_SKIN		= (1 << 4),	// XL

	STREAM_MAX
};

// Xg[NX
class Stream
{
private:

	LPDIRECT3DVERTEXDECLARATION9			m_Declaration;	// _\
	std::vector<LPDIRECT3DVERTEXBUFFER9>	m_VertexBuffer;	// _obt@
	LPDIRECT3DINDEXBUFFER9					m_IndexBuffer;	// CfbNXobt@
	std::vector<unsigned int>				m_BufSize;		// _obt@TCY


	// ʒuA@
	typedef struct _VERTEXPOSNOR_
	{
		D3DXVECTOR3 Pos;	// _ʒu
		D3DXVECTOR3 Nor;	// @
	}VERTEXPOSNOR,*LPVERTEXPOSNOR;

	// ڐ
	typedef struct _TANGENT_
	{
		D3DXVECTOR3 Tangent;
	}VERTEXTANGENT,*LPVERTEXTANGENT;

	// UV
	typedef struct _VERTEXUV_
	{
		D3DXVECTOR2 UV;		// UV
	}VERTEXUV,*LPVERTEXUV;

	// _J[
	typedef struct _VERTEXCOLOR_
	{
		DWORD Color;		// _J[
	}VERTEXCOLOR,*LPVERTEXCOLOR;

	// XL
	static const int BLENDMAX = 4;	// _ufBȌ
	typedef struct _VERTEXSKIN_
	{
		float	Weights[BLENDMAX];	// EFCg
		byte	Indices[BLENDMAX];	// CfbNX
	}VERTEXSKIN,*LPVERTEXSKIN;
	
	// _obt@̍쐬
	bool CreateVertexBuf(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh,unsigned int Flag);
	// CfbNXobt@̍쐬
	bool CreateIndexBuf(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh);
	
protected:
	
	// Xg[̍쐬
	bool CreateStream(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh,unsigned int Flag);
	// Xg[Zbg
	bool SetStream(IDirect3DDevice9* pD3DDevice);
	// Xg[NA
	bool ClearStream(IDirect3DDevice9* pD3DDevice);
	// v~eBu`
	bool DrawPrimitive(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh,int PrimitiveNum);

public:
	// RXgN^
	Stream();
	// fXgN^
	virtual ~Stream();

};

#endif