//------------------------------//
//	Xt@C[_[
//
//	쐬ҁF		Daiki Terai
//	쐬F		2010/04/08
//	C:	2011/08/08
//------------------------------//


#ifndef _XFILELOADER_H_
#define _XFILELOADER_H_

#include "direct3dmodel.h"
#include <iostream>
#include <fstream>

// g[N̍ő啶
#define MAX_TOKEN 64

class XFileLoader
{
public:
	//---------------------------------//
	//	fǂݍ
	//	
	//	F	FileName	t@C
	//			pOutModel	ǂݍݑΏۂƂȂ郂f|C^
	//	
	//	߂lF true:		ǂݍݐ
	//			false:		ǂݍݎs
	//---------------------------------//
	static bool Load(const TCHAR* FileName,LPMODEL pOutModel);

private:
	// t@C\̂ւ̃|C^
	static FILE*					m_FP;
	// fBNgpX
	static TCHAR					m_Dir[MAX_PATH];
	// ݂̃g[N
	static TCHAR					m_Token[MAX_TOKEN];

	//---------------------------------------------------
	// g[N̎擾
	//
	// F	Token		g[Nʂ
	//
	// ߂l	true:		g[N擾
	//			false:		g[N擾s
	//---------------------------------------------------
	static bool GetToken(TCHAR* Token);


#pragma region Mesh

////////////////////////////////////////////////////////////////////////////////

	//----------------------------------//
	//	bV̓ǂݎ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadMesh(LPMESH pMesh);

	//----------------------------------//
	//	_ʒu̓ǂݎ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadPos(LPMESH pMesh);

	//----------------------------------//
	//	ʏiCfbNXj̓ǂݎ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadFace(MESH* pMesh);

	//----------------------------------//
	//	_@̓ǂݎ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadNormal(LPMESH pMesh);

	//----------------------------------//
	//	_UV̓ǂݎ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadUV(LPMESH pMesh);

	//----------------------------------//
	//	XLbVwb_ǂݍ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lF	trueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadSkinMeshHeader(LPMESH pMesh);

	//----------------------------------//
	//	XLEFCgǂݍ
	//
	//	F	pMesh		bV|C^
	//			SkinIndex	XLԍ
	//
	//	߂lF	trueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadSkinWeights(LPMESH pMesh,int SkinIndex);

	//----------------------------------//
	//	}eAXg̓ǂݎ
	//
	//	F	pMesh	bV|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadMaterialList(LPMESH pMesh);

	//----------------------------------//
	//	}eA̓ǂݎ
	//
	//	F	pMaterial	}eA|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadMaterial(LPMATERIAL pMaterial);

	//----------------------------------//
	//	eNX`̓ǂݎ
	//
	//	F	pMaterial	}eA|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//----------------------------------//
	static bool LoadTexture(LPMATERIAL pMaterial);

////////////////////////////////////////////////////////////////////////////////

	//--------------------------------------//
	//	ʂOp`
	//
	//	F	pMesh	bVւ̃|C^
	//--------------------------------------//
	static void Trianglate(LPMESH pMesh);

	//--------------------------------------//
	//	@쐬
	//
	//	F	pMesh	bVւ̃|C^
	//--------------------------------------//
	static void CreateNormal(LPMESH pMesh);

	//--------------------------------------//
	//	ڐ쐬
	//
	//	F	pMesh	bVւ̃|C^
	//--------------------------------------//
	static void CreateTangent(LPMESH pMesh);

////////////////////////////////////////////////////////////////////////////////

	//--------------------------------------//
	//	ʂ\[g
	//
	//	F	pMesh	bVւ̃|C^
	//--------------------------------------//
	static void SortFaces(LPMESH pMesh);


////////////////////////////////////////////////////////////////////////////////

#pragma endregion

	
#pragma region Frame

	
	//------------------------------------------------
	//	t[sǂݍ
	//
	//	F	pMatrix	eւ̍s
	//
	//	߂lF	trueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//------------------------------------------------
	static bool LoadFrameMatrix(D3DXMATRIX* pMatrix);

#pragma endregion

#pragma region Animation

	//------------------------------------------------
	//	Aj[VZbgǂݍ
	//
	//	F	pAnimationSet:	Aj[VZbgւ̃|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//------------------------------------------------
	static bool LoadAnimationSet(LPANIMATIONSET pAnimationSet);

	//------------------------------------------------
	//	Aj[Vǂݍ(e{[̃L[t[)
	//
	//	F	pKeyFrame:	L[t[ւ̃|C^
	//
	//	߂lF	trueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//------------------------------------------------
	static bool LoadAnimation(LPKEYFRAME pKeyFrame);

	//------------------------------------------------
	//	Aj[VL[ǂݍ
	//
	//	F	pKeyFrame:	L[t[ւ̃|C^
	//
	//	߂lFtrueF	ǂݎ萬
	//			falseF	ǂݎ莸s
	//------------------------------------------------
	static bool LoadAnimationKey(LPKEYFRAME pKeyFrame);

#pragma endregion


};


#endif