//------------------------------//
//	Xt@CbVǂݍ
//
//	쐬ҁFDaiki Terai
//	쐬F2010/04/08
//	C
//------------------------------//

#include "xfileloader.h"
#include <algorithm>
#include <functional>


//----------------------------------//
//	bV̓ǂݎ
//
//	F	pMesh	bV|C^
//
//	߂lF	trueF	ǂݎ萬
//			falseF	ǂݎ莸s
//----------------------------------//
bool XFileLoader::LoadMesh(LPMESH pMesh)
{

	// bVJn
	GetToken(m_Token);
	// bV݂
	if(_tcscmp(m_Token,_T("{")) != 0){
		pMesh->Name = m_Token;
		GetToken(m_Token);
		ASSERT_EX(_tcscmp(m_Token,_T("{")) == 0,_T("悩ʃG["));
	}

	// _\tH[}bgtO
	pMesh->Format = 0;

	// _ʒu̓ǂݎ
	LoadPos(pMesh);
	pMesh->Format |= VF_POS;

	// ʏ̓ǂݎ
	LoadFace(pMesh);

	// XL̃CfbNX
	int SkinIndex = 0;

	// ̃bV͏s
	while(true)
	{
		GetToken(m_Token);
		// bVĨubN
		if(!_tcscmp(m_Token,_T("}")))
			break;
		
		// _@̓ǂݎ
		if(!_tcscmp(m_Token,_T("MeshNormals")))
		{
			LoadNormal(pMesh);
			pMesh->Format |= VF_NORMAL;
			continue;
		}

		// _UV̓ǂݎ
		if(!_tcscmp(m_Token,_T("MeshTextureCoords")))
		{
			LoadUV(pMesh);
			pMesh->Format |= VF_UV;
			continue;
		}

		// }eAXg̓ǂݎ
		if(!_tcscmp(m_Token,_T("MeshMaterialList")) )
		{
			LoadMaterialList(pMesh);
			continue;
		}

		//XLbVwb_[
		if(!_tcscmp(m_Token,_T("XSkinMeshHeader")))
		{
			LoadSkinMeshHeader(pMesh);
			pMesh->Format |= VF_SKIN;
			continue;
		}

		//XLEFCg
		if(!_tcscmp(m_Token,_T("SkinWeights")))
		{
			LoadSkinWeights(pMesh,SkinIndex);
			SkinIndex++;
			continue;
		}
		
		// bV̒_J[
		// ܂ƂgȂ̂Ŕ΂
		if(!_tcscmp(m_Token,_T("MeshVertexColors")))
		{
			while(true)
			{
				if(!_tcscmp(m_Token,_T("}")))
					break;

				GetToken(m_Token);
			}
			pMesh->Format |= VF_COLOR;
			continue;
		}

		// gȂ
		if(		!_tcscmp(m_Token,_T("VertexDuplicationIndices"))	// bV̂ǂ̒_݂ɏdĂ邩
			||	!_tcscmp(m_Token,_T("DeclData")))					// _\Lq
		{

			while(true)
			{
				if(!_tcscmp(m_Token,_T("}")))
					break;

				GetToken(m_Token);
			}
			continue;
		}

		// ȊȌ͓ǂݔ΂
		ASSERT_MSG(_T("̃bVf[^łAvmF\n"));
		while(true)
		{
			if(!_tcscmp(m_Token,_T("}")))
				break;

			GetToken(m_Token);
		}
		continue;
		
	}

	// ʂOp`
	Trianglate(pMesh);

	// @񂪂Ȃ̂ō
	if( (pMesh->Format & VF_NORMAL) == 0){
		pMesh->Format |= VF_NORMAL;
		CreateNormal(pMesh);
	}

	// ڐ쐬(UVȂƍȂ)
	if( (pMesh->Format & VF_UV) == 0){
		pMesh->Format |= VF_TANGENT;
		CreateTangent(pMesh);
	}

	// ʂ}eAɃ\[g
	SortFaces(pMesh);

	return true;
}

//--------------------------------------//
//	ʂOp`
//
//	F	pMesh	bVւ̃|C^
//--------------------------------------//
void XFileLoader::Trianglate(LPMESH pMesh)
{
	std::vector<FACE> faces;	// Op`
	faces.reserve(pMesh->Faces.size());

	FACE face;
	face.VertexIndex.resize(3);
	for(unsigned int i = 0;i < pMesh->Faces.size();++i){
		
		// Op`Ȃ炻̂܂ܑ
		if(pMesh->Faces[i].VertexIndex.size() == 3){
			faces.push_back(pMesh->Faces[i]);
		}
		// łȂΕ
		else{
			face.MatrialIndex = pMesh->Faces[i].MatrialIndex;
			for(unsigned int j = 0;j < pMesh->Faces[i].VertexIndex.size() - 2;++j){
				face.VertexIndex[0] = pMesh->Faces[i].VertexIndex[0];
				face.VertexIndex[1] = pMesh->Faces[i].VertexIndex[1 + j];
				face.VertexIndex[2] = pMesh->Faces[i].VertexIndex[2 + j];
				faces.push_back(face);
			}
		}
	}
	pMesh->Faces.clear();
	pMesh->Faces = faces;
}

//--------------------------------------//
//	@쐬
//
//	F	pMesh	bVւ̃|C^
//--------------------------------------//
void XFileLoader::CreateNormal(LPMESH pMesh)
{
	
	D3DXVECTOR3 v1,v2,v3;

	//O
	for(unsigned int i = 0;i < pMesh->Faces.size();++i)
	{
		v1 = pMesh->Vertices[pMesh->Faces[i].VertexIndex[1]].Pos - pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Pos;
		v2 = pMesh->Vertices[pMesh->Faces[i].VertexIndex[2]].Pos - pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Pos;

		// ʖ@
		D3DXVec3Cross(&v3, &v1,&v2);

		// R_ɓ̖@
		pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Normal+= v3;
		pMesh->Vertices[pMesh->Faces[i].VertexIndex[1]].Normal+= v3;
		pMesh->Vertices[pMesh->Faces[i].VertexIndex[2]].Normal+= v3;


	}

	//Ki_@j
	for(unsigned int i = 0;i < pMesh->Vertices.size();++i)
		D3DXVec3Normalize(&pMesh->Vertices[i].Normal,&pMesh->Vertices[i].Normal);			
	
}

// D3DXVECTOR4 CalcTangent
// _3UVWRƖ@ƂɐڐvZBԂ4xNgw͍En̔fptOB
D3DXVECTOR4 CalcTangent(const D3DXVECTOR3& v1, const D3DXVECTOR3& v2,const D3DXVECTOR3& v3,
						const D3DXVECTOR2& uv1,const D3DXVECTOR2& uv2,const D3DXVECTOR2& uv3,
						const D3DXVECTOR3& normal)
{
	D3DXVECTOR3 tangent;
	D3DXVECTOR3 bitangent;

	// GbW̌
    D3DXVECTOR3 edge1=v2-v1;
    D3DXVECTOR3 edge2=v3-v1;
    D3DXVec3Normalize(&edge1, &edge1);
    D3DXVec3Normalize(&edge2, &edge2);
	// UV̌
    D3DXVECTOR2 uvEdge1=uv2-uv1;
    D3DXVECTOR2 uvEdge2=uv3-uv1;
    D3DXVec2Normalize(&uvEdge1, &uvEdge1);
    D3DXVec2Normalize(&uvEdge2, &uvEdge2);
    
    float det=(uvEdge1.x * uvEdge2.y) - (uvEdge1.y * uvEdge2.x);
	det= 1.0f / det;

    tangent.x=(uvEdge2.y * edge1.x - uvEdge1.y * edge2.x) * det;
    tangent.y=(uvEdge2.y * edge1.y - uvEdge1.y * edge2.y) * det;
    tangent.z=(uvEdge2.y * edge1.z - uvEdge1.y * edge2.z) * det;
    
    bitangent.x=(-uvEdge2.x * edge1.x + uvEdge1.x * edge2.x) * det;
    bitangent.y=(-uvEdge2.x * edge1.y + uvEdge1.x * edge2.y) * det;
    bitangent.z=(-uvEdge2.x * edge1.z + uvEdge1.x * edge2.z) * det;

    D3DXVec3Normalize(&tangent, &tangent);
    D3DXVec3Normalize(&bitangent, &bitangent);

    D3DXVECTOR3 BiNormal;
    D3DXVec3Cross(&BiNormal, &normal, &tangent);

    float w=(D3DXVec3Dot(&BiNormal, &bitangent) >=0.0f) ? 1.0f : -1.0f;

	return D3DXVECTOR4(tangent.x,tangent.y,tangent.z, w);
}

//--------------------------------------//
//	ڐ쐬
//
//	F	pMesh	bVւ̃|C^
//--------------------------------------//
void XFileLoader::CreateTangent(LPMESH pMesh)
{
	D3DXVECTOR3 v1,v2,n;

	for(unsigned int i = 0;i < pMesh->Faces.size();++i){

		v1 = pMesh->Vertices[pMesh->Faces[i].VertexIndex[1]].Pos - pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Pos;
		v2 = pMesh->Vertices[pMesh->Faces[i].VertexIndex[2]].Pos - pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Pos;

		// ʖ@
		D3DXVec3Cross(&n, &v1,&v2);

		D3DXVECTOR4 Tangent = CalcTangent(
			pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Pos,
			pMesh->Vertices[pMesh->Faces[i].VertexIndex[1]].Pos,
			pMesh->Vertices[pMesh->Faces[i].VertexIndex[2]].Pos,
			pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].UV,
			pMesh->Vertices[pMesh->Faces[i].VertexIndex[1]].UV,
			pMesh->Vertices[pMesh->Faces[i].VertexIndex[2]].UV,
			n
			);

		pMesh->Vertices[pMesh->Faces[i].VertexIndex[0]].Tangent = Tangent;
		pMesh->Vertices[pMesh->Faces[i].VertexIndex[1]].Tangent = Tangent;
		pMesh->Vertices[pMesh->Faces[i].VertexIndex[2]].Tangent = Tangent;
	}

}


// q֐
bool Pre_Func(const FACE& a,const FACE& b)
{
	if(a.MatrialIndex < b.MatrialIndex)
		return true;

	return false;
}

//--------------------------------------//
//	ʂ\[g
//
//	F	pMesh	bVւ̃|C^
//--------------------------------------//
void XFileLoader::SortFaces(LPMESH pMesh)
{
	// ʂ}eAԍɃ\[g
	std::stable_sort(pMesh->Faces.begin(),pMesh->Faces.end(),Pre_Func);

	// \[gA}eAƂ̃v~eBuƕςڂ̔ԍ𒲂ׂ
	// }eA̋ڂ̔ԍoĂ
	int MaterialIndex = pMesh->Faces[0].MatrialIndex;
	int FaceCount = 0;			// ʂ̗݌v
	for(unsigned int i = 0;i < pMesh->Faces.size();++i){
		
		if(MaterialIndex == pMesh->Faces[i].MatrialIndex)
			continue;

		// ڃ
		PRIMITIVE Primitive = {};
		Primitive.FaceNum = i - FaceCount;
		Primitive.StartFaceIndex = FaceCount; // CfbNXobt@̊Jnʒu/3
		Primitive.MaterialIndex = MaterialIndex;
		pMesh->Primitives.push_back(Primitive);

		FaceCount = i;
		MaterialIndex = pMesh->Faces[i].MatrialIndex;
	}
	// Ō̃v~eBu
	PRIMITIVE Primitive = {};
	Primitive.FaceNum = pMesh->Faces.size() - FaceCount;
	Primitive.StartFaceIndex = FaceCount; // CfbNXobt@̊Jnʒu/3
	Primitive.MaterialIndex = MaterialIndex;
	pMesh->Primitives.push_back(Primitive);
}