
#include "xfileloader.h"

//----------------------------------//
//	XLbVwb_ǂݍ
//
//	F	pMesh	bV|C^
//
//	߂lF	trueF	ǂݎ萬
//			falseF	ǂݎ莸s
//----------------------------------//
bool XFileLoader::LoadSkinMeshHeader(LPMESH pMesh)
{
	GetToken(m_Token);
	ASSERT_EX(_tcscmp(m_Token,_T("{")) == 0,_T("悩ʃG["));

	// P_ɂőŉ̃{[e^邩
	GetToken(m_Token);
	// SzĂ珈łȂ
	ASSERT_EX(_tstoi(m_Token) <= 4,_T("1_ɑ΂ĉe^{[S𒴂Ă܂\n"));

	for(unsigned int i = 0;i < pMesh->Vertices.size();++i){
		pMesh->Vertices[i].Blend.reserve(_tstoi(m_Token));		
	}

	// 1v~eBue󂯂{[̐
	GetToken(m_Token);
	// ̃bVɉe^{[̐
	GetToken(m_Token);
	pMesh->Skins.resize(_tstoi(m_Token));

	GetToken(m_Token);
	ASSERT_EX(_tcscmp(m_Token,_T("}")) == 0,_T("悩ʃG["));

	return true;
}

//----------------------------------//
//	XLEFCgǂݍ
//
//	F	pMesh		bV|C^
//			SkinIndex	XLԍ
//
//	߂lF	trueF	ǂݎ萬
//			falseF	ǂݎ莸s
//----------------------------------//
bool XFileLoader::LoadSkinWeights(LPMESH pMesh,int SkinIndex)
{
	GetToken(m_Token);
	ASSERT_EX(_tcscmp(m_Token,_T("{")) == 0,_T("悩ʃG["));

	// {[擾
	GetToken(m_Token);
	pMesh->Skins[SkinIndex].BoneName = m_Token;

	// e钸_
	GetToken(m_Token);
	std::vector<int>	VertexIndices(_tstoi(m_Token));
	std::vector<float>	VertexWeights(_tstoi(m_Token));

	// _CfbNXꎞۑ
	for(unsigned int i = 0;i < VertexIndices.size();++i)
	{
		GetToken(m_Token);
		VertexIndices[i] = _tstoi(m_Token);
	}

	// _EFCgꎞۑ
	for(unsigned int i = 0;i < VertexWeights.size();++i)
	{
		GetToken(m_Token);
		VertexWeights[i] = static_cast<float>(_tstof(m_Token));
	}

	// _i[
	for(unsigned int i = 0;i < VertexIndices.size();++i)
	{
		VERTEXBLEND blend = { VertexWeights[i],SkinIndex };
		pMesh->Vertices[VertexIndices[i]].Blend.push_back(blend);
	}

	// ItZbgsۑ
	for(int i = 0;i < 4;++i){
		for(int j = 0;j < 4;++j){
			GetToken(m_Token);
			pMesh->Skins[SkinIndex].OffsetMtx.m[i][j] = static_cast<float>(_tstof(m_Token));
		}	
	}

	GetToken(m_Token);
	ASSERT_EX(_tcscmp(m_Token,_T("}")) == 0,_T("悩ʃG["));

	return true;
}
